<template>
  <bar-container v-slot="{ hideBar }">
    <!-- If forcing creation bar, init tabs with tab 1 instead of 0 -->
    <bar-tabs
      v-model="openedBar"
      :tabs="{
        sync: { label: $t('button.edit'), icon: 'mdi-pencil'},
        tap: { label: $t('button.tap'), icon: 'mdi-hand-clap'},
      }"
      @hide="hideBar()"
    >
      <!-- the sync bar tab -->
      <template #sync>
        <sync-bar
          ref="bar"
          :actions="actions"
          :signature="piece.signature"
          source-field-type="onset"
          target-field-type="second"
          :second-unit="secondUnit"
          @toggle-translator="$emit('toggle-translator')"
          @reset-sync="(t) => $emit('reset-sync', t)"
        />
      </template>
      <!-- the tap bar tab -->
      <template #tap>
        <tap-bar
          :actions="actions"
          :signature="piece.signature"
          :is-tapping.sync="isTappingSync"
          :is-countdown.sync="isCountdownSync"
          :playing.sync="playingSync"
          :real-time="realTime"
          :set-time="setTime"
          :possible-increments="possibleIncrements"
          @skip="(incr) => skip(incr)"
        />
      </template>
    </bar-tabs>
    <slot name="player" />
  </bar-container>
</template>

<script lang="ts">
import {
  Vue, Component, Ref, Prop, PropSync,
} from 'vue-property-decorator';

import type {
  Onset,
  Piece, Second, Unit,
} from '@/data';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import SyncBar from './synchronization/SyncBar.vue';
import type { Increment } from './synchronization/TapBar.vue';
import TapBar from './synchronization/TapBar.vue';
import BarContainer from './toolbar-container/BarContainer.vue';
import BarTabs from './toolbar-container/BarTabs.vue';

// Logic

import type ITools from './ITools';

/**
 * The main dezrann integration
 *
 * Displays a piece analysis and lets a user modify it
 */
@Component({
  components: {
    BarTabs,
    BarContainer,
    SyncBar,
    TapBar,
  },
})
export default class SyncTools extends Vue implements ITools {
  @Prop()
  possibleIncrements!: Increment[];

  @Prop({ required: true })
  piece!: Piece;

  @Prop({ required: true })
  actions!: SynchronizationActions;

  @PropSync('isTapping', { required: true })
  isTappingSync!: boolean;

  @PropSync('isCountdown', { required: true })
  isCountdownSync!: boolean;

  @PropSync('playing', { required: true })
  playingSync!: boolean;

  @Prop({ required: true })
  realTime!: Second | null;

  @Prop({ required: true })
  setTime!: (onset: Onset) => void;

  @Prop({ required: true })
  secondUnit!: Unit<Second>;

  openedBar = 0;

  // Editor bar ref for focus
  @Ref()
  bar?: SyncBar;

  public async focus() {
    // On focus (unlike in analysis tool) switch to sync bar before transmitting focus call
    this.openedBar = 0;
    // Then try to focus the sync bar
    this.bar?.focus();
  }

  skip(increment: number) {
    this.$emit('skip', increment);
  }
}

</script>
<style scoped lang="scss">
.editor-tools {
  display: flex;
}
.toolbar {
  // width: min(100%, 1000px);
  width: 100%;
  align-self: center;
  flex-shrink: 1;
  z-index: 2;
  display: flex;
}
.editor-tab {
  justify-content: left;
}
</style>
